//WWWWW'''''''''''WW'''''''''''''''''WW''''WW''''''''''
//WW                                 WWW  WWW          
//WWWW  WWW  WW W WW W WW  WW   WWW  W WWW WW  WWW WWW 
//WW    WW W WW W WW WW   WW W  WW W W  W  WW W WW WW W
//WW    WW W WW W WW WW   WW W  WW W W     WW W WW WW W
//WWWWW WW W  WW  WW WW    WW   WW W W     WW  WWW WWW 
//                                                 WW  
//'''''''''''''''''''''''''''''''''''''''''''''''''WW''

#ifndef ENVIRONMAPCLASS
#define ENVIRONMAPCLASS

#include "Main.h"
#include "GlobalVars.h"
#include "Ray.h"
#include "Pane.h"

class EnvironMap {

  protected:
  
  GlobalVars *gv;

  private:
  
  SbColor *data;
  SbColor *data3;  // downsampled lat/long graymap for debugging
  int dim[2];
  int dim2[2];
  int dimll[2];
  float **pweights, *cweights;
  double *samples1, *samples2;
  int samples;
  
  public:
  
  SbColor Lavg;
  SbRotation rot;
  
  EnvironMap();
  ~EnvironMap();
  
  virtual void init(GlobalVars *gv_);
  virtual SbColor impSample(Ray &r, SbVec3f &n, SbVec3f &ng, int simple=0);
  virtual SbColor volImpSample(Ray &r, int simple);  
  virtual float getSample(double eps1, double eps2,
		  SbVec3f &dir, SbColor &c);
  virtual SbColor getRadiance(SbVec3f &dir);
  void writeData3();
};

#endif /* ENVIRONMAPCLASS */
  
