#include <string>

#ifndef FILEUTILS_H
#define FILEUTILS_H

class SbColor;

namespace Imf {
  struct Rgba;
}

using namespace std;

class FileUtils {
public:
  static void checkForOverwrite(const string &filename,
                                bool createBackup);
  static void writeHDR(const int imgDim[2], const string &imgFile, 
                       const SbColor *pix, bool createBackup);

  static void writeEXR(const int imgDim[2], const string &imgFile, 
                       const SbColor *pix, bool createBackup);
  
  static void writeHDR(const int imgDim[2], const string &imgFile, 
                       const float *pix){
    writeHDR(imgDim, imgFile, (const SbColor *)pix, false);
  }

  static void writeRgba1(const string &filename,
                         const Imf::Rgba *pixels,
                         int width, int height);

  static void writeEXR(const int imgDim[2], const string &imgFile, 
                       const float *pix){
    writeEXR(imgDim, imgFile, (const SbColor *)pix, false);
  }
  
  static bool writeDepth(const int imgDim[2], const string &imgFile,
                         const float *pixDepth, bool createBackup);

  static float* readPFM(const int imgDim[2], const string &filename,
                        bool verbose=false);

  static bool writePNG(const int imgDim[], const string &filename,
                       const SbColor *pix, float gamma,
                       const string &comment=NULL);
};

#endif
