//WW''''WW'''''''WW''''''''''''WW''''''WWW''''''''''WWW''''''''''''''''''
//WWW  WWW       WW                     WW           WW                  
//W WWW WW  WWW WWWW  WW  W WW WW  WWW  WW      WWW  WW   WWW  WWWW  WWWW
//W  W  WW W WW  WW  WWWW WW   WW W WW  WW     WW W  WW  W WW WWW   WWW  
//W     WW W WW  WW  WW   WW   WW W WW  WW     WW    WW  W WW   WWW   WWW
//W     WW  WWW  WW   WWW WW   WW  WWW WWWW     WWW WWWW  WWW WWWW  WWWW 
//                                                                       
//'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

#include "Material.h"
#include "debug.h"
#include <assert.h>
Material::Material(){
  SoMaterial *tmpMat = new SoMaterial();
  tmpMat->ref();
  SoMatPlus *tmpMatPlus = new SoMatPlus();
  tmpMatPlus->ref();

  init(tmpMat, tmpMatPlus);

  tmpMat->unref();
  tmpMatPlus->unref();
  assert(matPlus != NULL);
}

Material::Material(SoMaterial *mat, SoMatPlus *matPlus) {
  init(mat, matPlus);
}

void Material::init(SoMaterial *mat, SoMatPlus *matPlus_) {
  static int newMats = 0;
  matPlus = (SoMatPlus *) matPlus_->copy();
  matPlus->ref();
  g = s = d = 0.0;
  ambientColor = mat->ambientColor[0];
  specular     = mat->specularColor[0];
  emission     = mat->emissiveColor[0];
  shininess    = mat->shininess[0];
  transparency = mat->transparency[0];

  // set boolean variables
  shiny = emissive = 0;
  emisAvg = 0;
  
  if (emission[R] + emission[G] + emission[B] >0.00001){
    emissive = 1;
    emisAvg = (emission[R] + emission[G] + emission[B]) * (1.0f/3.0f);
  }
  
  if (shininess>0.0 && (specular[R] + specular[G] + specular[B] > 0.00001))
    shiny = 1;

  //cerr << "Material():" << *this;
}

Material::~Material(){
  assert(matPlus);
  matPlus->unref();
}

ostream& operator<< (ostream& os, const Material& m){
  os << "Material ["
     << " ambientColor=" << m.ambientColor
     << " specular=" << m.specular
     << " emission=" << m.emission
     << " shiny=" << (m.shiny?"yes":"no")
     << " emissive=" << (m.emissive?"yes":"no")
     << " shininess=" << m.shininess
     << " transparency=" << m.transparency
     << " emisAvg=" << m.emisAvg;
  //os << " " << (SoMatPlus)m;
  os << " ]";
  return(os);
}

