//WW''''WW'''''''WW''''''''''''WW''''''WWW''''''''''WWW''''''''''''''''''
//WWW  WWW       WW                     WW           WW                  
//W WWW WW  WWW WWWW  WW  W WW WW  WWW  WW      WWW  WW   WWW  WWWW  WWWW
//W  W  WW W WW  WW  WWWW WW   WW W WW  WW     WW W  WW  W WW WWW   WWW  
//W     WW W WW  WW  WW   WW   WW W WW  WW     WW    WW  W WW   WWW   WWW
//W     WW  WWW  WW   WWW WW   WW  WWW WWWW     WWW WWWW  WWW WWWW  WWWW 
//                                                                       
//'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

// Contains copy of SoMaterial info plus pointer to
// SoMatPlus node. Used by pane to contain all material
// properties. SoMatPlus is a custom node for storing
// additional material descriptions in an inventor (.iv)
// file that are not already contained within the SoMaterial
// node.

#ifndef MATERIALCLASS
#define MATERIALCLASS

#include "Main.h"
#include "SoMatPlus.h"

class Material { 
  
  private:

  void init(SoMaterial *mat, SoMatPlus *matPlus);

  public:
  
  SoMatPlus *matPlus;
  
  float g, s, d;           // internal (private, automatically calculated)
  
  SbColor ambientColor;
  SbColor specular;
  SbColor emission;
  int shiny;
  int emissive;
  float shininess;
  float transparency;
  float emisAvg;

  Material();
  ~Material();
  Material(SoMaterial *mat, SoMatPlus *matPlus);
  friend ostream& operator<< (ostream& os, const Material& m);
  
};

#endif /* MATERIALCLASS */

