//WWWW''WW'''W''WWWW'''''''''WWW''''''''''''''''''
//WW  W WWW  W WW  W          WW                  
//WW  W W WW W WW        WWW  WW   WWW  WWWW  WWWW
//WWWW  W  WWW WW WW    WW W  WW  W WW WWW   WWW  
//WW  W W   WW WW  W    WW    WW  W WW   WWW   WWW
//WW  W W    W  WWWW     WWW WWWW  WWW WWWW  WWWW 
//                                                
//''''''''''''''''''''''''''''''''''''''''''''''''
// Random Number Generator class
// mostly out of Realistic Ray Tracing 2nd Ed.
// Uses a linear congruence algorithm.

#ifndef RNGCLASS
#define RNGCLASS

typedef unsigned long long ull_t;
class RNG {

  public:

  unsigned long long seed;
  static const unsigned long long mult      = 62089911ULL;
  static const unsigned long long llong_max = 4294967295ULL;
  static const float float_max              = 4294967295.0f;
  static const unsigned long long_max       = 2147483647L;
  
  RNG(unsigned long long _seed = 7564231ULL) : seed(_seed) { }

  float operator()(){
    static const float float_max_inv = 1./float_max;
    seed *= mult;
    return float(seed % llong_max) * float_max_inv;
    //return float(seed % llong_max) / float_max;
  }

  long lrand48(){
    seed *= mult;
    return long(seed % long_max);
  }
  
  void setSeed(unsigned long long _seed){ seed = _seed;  }
};
  

#endif /* RNGCLASS */

