
#ifndef RAYACCELCLASS
#define RAYACCELCLASS

#include "Main.h"
#include "Triangle.h"
#include "TriangleList.h"
class Ray; // forward declaration of Ray class

class RayAccel {
  
private:

  void error(const char *f);
  
protected:
  int num_tris;
  double maxSideLength;
  float min[3], max[3];

  // keep bounding sphere of triangles
  SbVec3f center;
  float radius;
  float shiny_radius;
  SbVec3f shiny_center;
  
public:

  RayAccel(){
    //error("RayAccel");
    num_tris = 0;
    maxSideLength = 0;
    min[0] = min[1] = min[2] = 0;
    max[0] = max[1] = max[2] = 0;
    center.setValue(0,0,0);
    radius = shiny_radius = 0;
    shiny_center.setValue(0,0,0);
  }
  virtual ~RayAccel(){ }
  virtual void reset(){ error("reset"); }

  virtual int add(Triangle *t){ error("add"); return 0; }

  virtual void printStats(){ error("printStats"); }
  virtual void setParams(int maxD, int maxI, int debug){ error("setParams"); }
  virtual void refine(int simpleDiv = 0){ error("refine"); }
  virtual int intersect_ray(Ray &r){ error("intersect_ray"); return 0; }
  virtual void reorderNodes(){ cerr << "error: RayAccel::reorderNodes()!\n"; }

  int size(){ /*Error("size");*/ return(num_tris); }
  double& getMaxSideLength(){ /*Error("getMaxSideLength");*/ return maxSideLength; }
  float* getMin(){ /*Error("getMin");*/ return min; }
  float* getMax(){ /*Error("getMax");*/ return max; }
  SbVec3f& getCenter(){ /*Error("getCenter");*/ return center; }
  float& getRadius(){ /*Error("getRadius");*/ return radius; }
  float& getShinyRadius(){ /*Error("getShinyRadius");*/ return shiny_radius; }
  SbVec3f& getShinyCenter(){ /*Error("getShinyCenter");*/ return shiny_center; }
};

#endif /* RAYACCELCLASS */
