
#ifndef SKYCLASS
#define SKYCLASS

#include "Main.h"
#include "GlobalVars.h"
#include "Ray.h"
#include "Pane.h"
#include "EnvironMap.h"

class Sky : public EnvironMap {

  SbVec3f sunBasisU, sunBasisV, sunBasisW;
  float sunRadiusAngle;
  SbColor sunRadiance;
  
  private:
  
  public:
  
  Sky();
  ~Sky();
  
  virtual void init(GlobalVars *gv);
  virtual SbColor impSample(Ray &r, SbVec3f &n, SbVec3f &ng, int simple=0);
  //virtual SbColor volImpSample(Ray &r, int simple);  
  virtual float getSample(double eps1, double eps2,
		  SbVec3f &dir, SbColor &c);
  virtual SbColor getRadiance(SbVec3f &dir);
};

#endif /* ENVIRONMAPCLASS */
  
