//WWWWWW'''''''WW''''''''''''''''WWW'''''''WW''''WW''''''''WW''''''''''WWW''
//  WW                            WW       WW              WW           WW  
//  WW    W WW WW  WWW WWW   WWW  WW   WW  WW    WW  WWWW WWWW     WWW  WW  
//  WW    WW   WW W WW WW W W WW  WW  WWWW WW    WW WWW    WW     WW W  WW  
//  WW    WW   WW W WW WW W W WW  WW  WW   WW    WW   WWW  WW     WW    WW  
//  WW    WW   WW  WWW WW W  WWW WWWW  WWW WWWWW WW WWWW   WW      WWW WWWW 
//                            WW                                            
//''''''''''''''''''''''''''WWW'''''''''''''''''''''''''''''''''''''''''''''

#include "TriangleList.h"
#include "intersect_ray_tri.h"
#include "Ray.h"

extern int DEBUG_STATE;

vector<Triangle *> TriangleList::allTris; // FIXME: This should be tri's not *'s
vector<EmissiveTriangle *> TriangleList::allEmisTris(1); // FIXME: This should be tri's not *'s
vector<bool> TriangleList::triBits;
vector<bool> TriangleList::emisTriBits;

void TriangleList::printBits2(){ printBits(); }


const int TriangleList::primSize[4] = {
  sizeof(Triangle *),
  sizeof(EmissiveTriangle *),
  0,
  0
};

Triangle* const TriangleList::primLists[4] = {
  (Triangle *)&TriangleList::allTris[0],
  (Triangle *)&TriangleList::allEmisTris[0],
  0x0,
  0x0
};
  

void TriangleList::deleteAll(){
  for (int i=0; i<allTris.size(); i++)
    delete allTris[i];
  allTris.clear();
  
  for (int i=0; i<allEmisTris.size(); i++)
    delete allEmisTris[i];
  allEmisTris.clear();
}

void TriangleList::drawAll(){
  for (int i=0; i<allTris.size(); i++)
    allTris[i]->show();
}

int plueckerIntTri(SbVec3f &orig, SbVec3f &dir,
		  Triangle *t,
		  double &t, double &u, double &v);

int TriangleList::intersect_ray(Ray &r, double t0, double t1, int checkDist) {

  double t, u, v;
  r.t = t1;
  r.triId = Ray::NO_TRI;
  r.bc[1] = r.bc[2] = 0;

  // loop over triangles
  for (int ti=0; ti<trilist.size(); ti++){

    // skip triangle
    int triId = id(ti);
    if (triId == r.ignoreId) continue;
    Triangle *tri = TriangleList::tri(ti);

    r.ctx->isects++;
    if (
      intersect_ray_tri(r.pos, r.dir, tri->vert[X],
			tri->vert[Y], tri->vert[Z],
			&t, &u, &v)
//      plueckerIntTri(r.pos, r.dir, tri, t, u, v)
      ){

      if (t<t0 || t>r.t)
	continue; // implicit: || t>t1

      // store triangle distance, pointer, barycentric coords
      r.t = t;
      r.triId = triId;
      r.tri = tri;
      r.bc[1] = u;
      r.bc[2] = v;
    }
  }

  // calculate third barycentric coordinate
  // FIXME: can be delayed
  r.bc[0] = 1.0f-r.bc[1]-r.bc[2];
  
  return(r.triId!=Ray::NO_TRI);
}

int plueckerIntTri(SbVec3f &orig, SbVec3f &dir,
		  Triangle *tri,
		  double &t, double &u, double &v){
  SbVec3f vert0 = tri->vert[0]-orig;
  SbVec3f vert1 = tri->vert[1]-orig;
  SbVec3f vert2 = tri->vert[2]-orig;
  
  int result = dir.dot(vert0.cross(vert1))<0.f;
  if (result != dir.dot(vert1.cross(vert2))<0.f) return 0;
  if (result != dir.dot(vert2.cross(vert0))<0.f) return 0;

  SbVec3f n = tri->getNormal();
  t = n.dot(vert0)/(double)n.dot(dir);
  u = v = 0.3333;
  return 1;
}
